import requests
import numpy as np


classify_url = "http://127.0.0.1:3330/classify"

labels = [
    "Prima Nota",
    "Documento di Acquisto",
    "Carta di Credito",
    "Contabile Banca",
    "Documento di Vendita",
    "Rimborso",
    "Estratto Conto Banca"
]

def classify_doc(imgs: np.ndarray):
    from visualdocclassification_8_pb2 import FlatImage, FlatImages
    images_list = []
    for k in range(imgs.shape[0]):
        img = imgs[k,:,:,:]

        if len(img.shape) == 2:
            h = int(img.shape[0])
            w = int(img.shape[1])
            myFI = FlatImage(image=[float(i) for i in img.reshape(h*w)], shape=[h, w, 1])
        elif len(img.shape) == 3:
            h = int(img.shape[0])
            w = int(img.shape[1])
            c = int(img.shape[2])
            myFI = FlatImage(image=[float(i) for j in range(c) for i in list(img[:, :, j].reshape(h*w))], shape=[h, w, c])
        else:
            print('Wrong dimensions. Probably not an image')
            exit(1)

        images_list.append(myFI)

    image_named_tuple = FlatImages(images=images_list)

    post_req = requests.post(
        classify_url,
        image_named_tuple.SerializeToString()
    )

    from visualdocclassification_8_pb2 import ClassifyOut
    of = ClassifyOut()
    of.ParseFromString(post_req.content)

    return of.value



def main():
    from keras.preprocessing.image import load_img, img_to_array
    from keras.applications.resnet50 import preprocess_input
    # # load an image from file
    img = load_img('sample.jpg', target_size=(224, 224))
    # # convert the image pixels to a numpy array
    img = img_to_array(img)
    # # preparing the image for the model

    class_pred = classify_doc(np.array([img]))
    # class_pred = classify_doc(np.array([img, img]))

    for c in class_pred:
        print('Predicted: {}'.format(labels[c]))


if __name__ == '__main__':
    main()
